
;intframe
	push af
	ex af,af'
	push af
	ld (BC1tmp+1),bc
	ld (DE1tmp+1),de
	ld (HL1tmp+1),hl
	exx
	ld (BC2tmp+1),bc
	ld (DE2tmp+1),de
	ld (HL2tmp+1),hl
	pop hl
	ld (AF2tmp+1),hl
	pop hl
	ld (AF1tmp+1),hl

	if intout0 = 1
	xor a
	out (beepport),a
	endif

	if intvolreset = 0
	ld a,iyl
	ld (IYLtmp),a
	endif
		
	call mpplayaddr

	call ay48int1


	if intvolreset = 0
	ld a,(IYLtmp)
	ld iyl,a
	else
	xor a
	ld iyl,a	
	endif


af2regsrestorecall
	call af2restore
	push hl
	pop af
	ex af,af'

regs2restorecall
	call regs2restore
	exx

af1regsrestorecall
	call af1restore
	push hl
	pop af

regs1restorecall
	call regs1restore


	ei
	reti

regsaltrestore	
		ld bc,altrbcbprt
enshp		ld d,senshp	;$00
noiza		ld e,smxe	;$00	
noizb		ld h,smxe	;$00
noizc		ld l,smxe	;$00
		ret

regs1restore
BC1tmp		ld bc,$0000
DE1tmp		ld de,$0000
HL1tmp		ld hl,$0000
		ret

regs2restore
BC2tmp		ld bc,$0000
DE2tmp		ld de,$0000
HL2tmp		ld hl,$0000
		ret

afaltrestore
nztab		ld h,nztabhaddr
		ret

af1restore
AF1tmp		ld hl,$0000
		ret

af2restore
AF2tmp		ld hl,$0000
		ret

IYLtmp		defw $0000




ay48int1

altdetect

	ld a,(BC1tmp+2)
	cp altregb 
	jp nz,r2alt

r1alt	ld hl,regs2restore
	ld (regs2restorecall+1),hl
	
	ld hl,regsaltrestore
	ld (regs1restorecall+1),hl
	jp altdetect1

r2alt	ld hl,regsaltrestore
	ld (regs2restorecall+1),hl
	
	ld hl,regs1restore
	ld (regs1restorecall+1),hl


altdetect1

	ld a,(AF1tmp+2)
noizcp	ld c,nztabhaddr
	cp c
	jp nz,a2alt
a1alt
	ld a,(AF2tmp+2)
	cp c
	jp z,aalthz

	ld hl,afaltrestore
	ld (af1regsrestorecall+1),hl

	ld hl,af2restore
	ld (af2regsrestorecall+1),hl

	jp altdetect2
a2alt
	ld hl,af1restore
	ld (af1regsrestorecall+1),hl

	ld hl,afaltrestore
	ld (af2regsrestorecall+1),hl
	jp altdetect2

aalthz
	ld hl,af1restore
	ld (af1regsrestorecall+1),hl
	ld hl,af2restore
	ld (af2regsrestorecall+1),hl

altdetect2



;ayregsdecoder
